#include <math.h>
#include <stdio.h>

inline double function(double x)
{
  double f = (4.0/(1.0+x*x));
  return f;
}

double integral(double a, double h, int N);

int main(int argc, char* argv[])
{

  int num_inc = 10000; //number of increments in integral 

  double a = 0.0; //lower limit of integral  
  double b = 1.0; //upper limit of integral
  double h; //width of each increment 
  double final_result;    //final result 
  
  //calculate rengtangle width 
  h = (b-a)/num_inc;  

  //calculate integral
  final_result = integral(a, h, num_inc);  

  printf("The final result = %.9g\n", final_result);

  return 0;
}

//numerical integral using midpoint rule 
//args: a = lower limit of integration
//      h = rectangle width
//      N = number of rectangles

double integral(double a, double h, int N)
{
  int j;
  double hd2 = h/2.0;
  double aj;
  double int_sum = 0.0;

  //midpoint rule
  for (j=0; j<N; j++) {        
    aj = a + j*h;     
    int_sum += function(aj+hd2)*h;  //sum up function evaluated at midpoint * interval width
  }  
  return int_sum;
}
